diff --git a/drupal7/sites/all/modules/ldap/ldap_servers/LdapServer.class.php b/drupal7/sites/all/modules/ldap/ldap_servers/LdapServer.class.php
index 4b79af1c..f8c90867 100644
--- a/drupal7/sites/all/modules/ldap/ldap_servers/LdapServer.class.php
+++ b/drupal7/sites/all/modules/ldap/ldap_servers/LdapServer.class.php
@@ -813,21 +901,27 @@ class LdapServer {
    *   (this array of parameters is primarily passed on to ldapQuery() method)
    *
    * @return array of ldap entries or FALSE on error.
-   *
    */
   public function pagedLdapQuery($ldap_query_params) {
 
     if (!($this->searchPagination && $this->paginationEnabled)) {
+      $watchdog_tokens = [
+        '%basedn' => $ldap_query_params['base_dn'],
+        '%filter' => $ldap_query_params['filter'],
+        '%attributes' => print_r($ldap_query_params['attributes'], TRUE),
+        '%errmsg' => $this->errorMsg('ldap'),
+        '%errno' => $this->ldapErrorNumber(),
+      ];
       watchdog('ldap_servers', "LDAP server pagedLdapQuery() called when functionality not available in php install or
         not enabled in ldap server configuration.  error. basedn: %basedn| filter: %filter| attributes:
          %attributes| errmsg: %errmsg| ldap err no: %errno|", $watchdog_tokens);
-      RETURN FALSE;
+      return FALSE;
     }
 
     $page_token = '';
     $page = 0;
     $estimated_entries = 0;
-    $aggregated_entries = array();
+    $aggregated_entries = [];
     $aggregated_entries_count = 0;
     $has_page_results = FALSE;
 
@@ -837,7 +931,7 @@ class LdapServer {
 
       if ($page >= $this->searchPageStart) {
         $skipped_page = FALSE;
-        if ($result && ($this->countEntries($result) !== FALSE) ) {
+        if ($result && ($this->countEntries($result) !== FALSE)) {
           $page_entries = ldap_get_entries($this->connection, $result);
           unset($page_entries['count']);
           $has_page_results = (is_array($page_entries) && count($page_entries) > 0);
@@ -845,12 +939,16 @@ class LdapServer {
           $aggregated_entries_count = count($aggregated_entries);
         }
         elseif ($this->ldapErrorNumber()) {
-          $watchdog_tokens = array('%basedn' => $ldap_query_params['base_dn'], '%filter' => $ldap_query_params['filter'],
-            '%attributes' => print_r($ldap_query_params['attributes'], TRUE), '%errmsg' => $this->errorMsg('ldap'),
-            '%errno' => $this->ldapErrorNumber());
+          $watchdog_tokens = [
+            '%basedn' => $ldap_query_params['base_dn'],
+            '%filter' => $ldap_query_params['filter'],
+            '%attributes' => print_r($ldap_query_params['attributes'], TRUE),
+            '%errmsg' => $this->errorMsg('ldap'),
+            '%errno' => $this->ldapErrorNumber(),
+          ];
           watchdog('ldap_servers', "LDAP ldap_search error. basedn: %basedn| filter: %filter| attributes:
             %attributes| errmsg: %errmsg| ldap err no: %errno|", $watchdog_tokens);
-          RETURN FALSE;
+          return FALSE;
         }
         else {
           return FALSE;
@@ -861,11 +959,11 @@ class LdapServer {
       }
       @ldap_control_paged_result_response($this->connection, $result, $page_token, $estimated_entries);
       if ($ldap_query_params['sizelimit'] && $this->ldapErrorNumber() == LDAP_SIZELIMIT_EXCEEDED) {
-        // false positive error thrown.  do not set result limit error when $sizelimit specified
+        // False positive error thrown.  do not set result limit error when $sizelimit specified.
       }
       elseif ($this->hasError()) {
         watchdog('ldap_servers', 'ldap_control_paged_result_response() function error. LDAP Error: %message, ldap_list() parameters: %query',
-          array('%message' => $this->errorMsg('ldap'), '%query' => $ldap_query_params['query_display']),
+          ['%message' => $this->errorMsg('ldap'), '%query' => $ldap_query_params['query_display']],
           WATCHDOG_ERROR);
       }
 
@@ -873,10 +971,12 @@ class LdapServer {
         $discarded_entries = array_splice($aggregated_entries, $ldap_query_params['sizelimit']);
         break;
       }
-      elseif ($this->searchPageEnd !== NULL && $page >= $this->searchPageEnd) { // user defined pagination has run out
+      // User defined pagination has run out.
+      elseif ($this->searchPageEnd !== NULL && $page >= $this->searchPageEnd) {
         break;
       }
-      elseif ($page_token === NULL || $page_token == '') { // ldap reference pagination has run out
+      // Ldap reference pagination has run out.
+      elseif ($page_token === NULL || $page_token == '') {
         break;
       }
       $page++;
@@ -887,9 +987,10 @@ class LdapServer {
   }
 
   /**
-   * execute ldap query and return ldap records
+   * Execute ldap query and return ldap records.
    *
    * @param scope
+   *
    * @params see pagedLdapQuery $params
    *
    * @return array of ldap entries
@@ -903,11 +1004,11 @@ class LdapServer {
         $result = @ldap_search($this->connection, $params['base_dn'], $params['filter'], $params['attributes'], $params['attrsonly'],
           $params['sizelimit'], $params['timelimit'], $params['deref']);
         if ($params['sizelimit'] && $this->ldapErrorNumber() == LDAP_SIZELIMIT_EXCEEDED) {
-          // false positive error thrown.  do not return result limit error when $sizelimit specified
+          // False positive error thrown.  do not return result limit error when $sizelimit specified.
         }
         elseif ($this->hasError()) {
           watchdog('ldap_servers', 'ldap_search() function error. LDAP Error: %message, ldap_search() parameters: %query',
-            array('%message' => $this->errorMsg('ldap'), '%query' => $params['query_display']),
+            ['%message' => $this->errorMsg('ldap'), '%query' => $params['query_display']],
             WATCHDOG_ERROR);
         }
         break;
@@ -916,11 +1017,11 @@ class LdapServer {
         $result = @ldap_read($this->connection, $params['base_dn'], $params['filter'], $params['attributes'], $params['attrsonly'],
           $params['sizelimit'], $params['timelimit'], $params['deref']);
         if ($params['sizelimit'] && $this->ldapErrorNumber() == LDAP_SIZELIMIT_EXCEEDED) {
-          // false positive error thrown.  do not result limit error when $sizelimit specified
+          // False positive error thrown.  do not result limit error when $sizelimit specified.
         }
         elseif ($this->hasError()) {
           watchdog('ldap_servers', 'ldap_read() function error.  LDAP Error: %message, ldap_read() parameters: %query',
-            array('%message' => $this->errorMsg('ldap'), '%query' => @$params['query_display']),
+            ['%message' => $this->errorMsg('ldap'), '%query' => @$params['query_display']],
             WATCHDOG_ERROR);
         }
         break;
@@ -929,11 +1030,11 @@ class LdapServer {
         $result = @ldap_list($this->connection, $params['base_dn'], $params['filter'], $params['attributes'], $params['attrsonly'],
           $params['sizelimit'], $params['timelimit'], $params['deref']);
         if ($params['sizelimit'] && $this->ldapErrorNumber() == LDAP_SIZELIMIT_EXCEEDED) {
-          // false positive error thrown.  do not result limit error when $sizelimit specified
+          // False positive error thrown.  do not result limit error when $sizelimit specified.
         }
         elseif ($this->hasError()) {
           watchdog('ldap_servers', 'ldap_list() function error. LDAP Error: %message, ldap_list() parameters: %query',
-            array('%message' => $this->errorMsg('ldap'), '%query' => $params['query_display']),
+            ['%message' => $this->errorMsg('ldap'), '%query' => $params['query_display']],
             WATCHDOG_ERROR);
         }
         break;
@@ -942,7 +1043,8 @@ class LdapServer {
   }
 
   /**
-   * @param array $dns Mixed Case
+   * @param array $dns
+   *   Mixed Case.
    * @return array $dns Lower Case
    */
   public function dnArrayToLowerCase($dns) {
@@ -950,7 +1052,7 @@ class LdapServer {
   }
 
   /**
-   * userUserEntityFromPuid.
+   * UserUserEntityFromPuid.
    *
    * @param string $puid
    *   Binary or string as returned from ldap_read or other ldap function.
@@ -961,10 +1063,11 @@ class LdapServer {
 
     $query = new EntityFieldQuery();
     $query->entityCondition('entity_type', 'user')
-    ->fieldCondition('ldap_user_puid_sid', 'value', $this->sid, '=')
-    ->fieldCondition('ldap_user_puid', 'value', $puid, '=')
-    ->fieldCondition('ldap_user_puid_property', 'value', $this->unique_persistent_attr, '=')
-    ->addMetaData('account', user_load(1)); // run the query as user 1
+      ->fieldCondition('ldap_user_puid_sid', 'value', $this->sid, '=')
+      ->fieldCondition('ldap_user_puid', 'value', $puid, '=')
+      ->fieldCondition('ldap_user_puid_property', 'value', $this->unique_persistent_attr, '=')
+    // Run the query as user 1.
+      ->addMetaData('account', user_load(1));
 
     $result = $query->execute();
 
@@ -976,7 +1079,7 @@ class LdapServer {
       }
       else {
         $uids = join(',', $uids);
-        $tokens = array('%uids' => $uids, '%puid' => $puid, '%sid' => $this->sid, '%ldap_user_puid_property' => $this->unique_persistent_attr);
+        $tokens = ['%uids' => $uids, '%puid' => $puid, '%sid' => $this->sid, '%ldap_user_puid_property' => $this->unique_persistent_attr];
         watchdog('ldap_servers', 'multiple users (uids: %uids) with same puid (puid=%puid, sid=%sid, ldap_user_puid_property=%ldap_user_puid_property)', $tokens, WATCHDOG_ERROR);
         return FALSE;
       }
@@ -1004,7 +1107,8 @@ class LdapServer {
       $watchdog_tokens['%code_result'] = $code_result;
       $ldap_username = $code_result;
       $watchdog_tokens['%ldap_username'] = $ldap_username;
-      $name = $old_name_value;  // important because of global scope of $name
+      // Important because of global scope of $name.
+      $name = $old_name_value;
       if ($this->detailedWatchdogLog) {
         watchdog('ldap_servers', '%drupal_user_name tansformed to %ldap_username by applying code <code>%code</code>', $watchdog_tokens, WATCHDOG_DEBUG);
       }
@@ -1013,19 +1117,18 @@ class LdapServer {
       $ldap_username = $drupal_username;
     }
 
-    // Let other modules alter the ldap name
-    $context = array(
+    // Let other modules alter the ldap name.
+    $context = [
       'ldap_server' => $this,
-    );
+    ];
     drupal_alter('ldap_servers_username_to_ldapname', $ldap_username, $drupal_username, $context);
 
     return $ldap_username;
 
   }
 
-
   /**
-   * userUsernameFromLdapEntry.
+   * UserUsernameFromLdapEntry.
    *
    * @param array $ldap_entry
    *
@@ -1034,11 +1137,10 @@ class LdapServer {
    */
   public function userUsernameFromLdapEntry($ldap_entry) {
 
-
     if ($this->account_name_attr) {
       $accountname = (empty($ldap_entry[$this->account_name_attr][0])) ? FALSE : $ldap_entry[$this->account_name_attr][0];
     }
-    elseif ($this->user_attr)  {
+    elseif ($this->user_attr) {
       $accountname = (empty($ldap_entry[$this->user_attr][0])) ? FALSE : $ldap_entry[$this->user_attr][0];
     }
     else {
@@ -1049,7 +1151,7 @@ class LdapServer {
   }
 
   /**
-   * userUsernameFromDn.
+   * UserUsernameFromDn.
    *
    * @param string $dn
    *
@@ -1058,7 +1160,7 @@ class LdapServer {
    */
   public function userUsernameFromDn($dn) {
 
-    $ldap_entry = @$this->dnExists($dn, 'ldap_entry', array());
+    $ldap_entry = @$this->dnExists($dn, 'ldap_entry', []);
     if (!$ldap_entry || !is_array($ldap_entry)) {
       return FALSE;
     }
@@ -1075,11 +1177,13 @@ class LdapServer {
    */
   public function userEmailFromLdapEntry($ldap_entry) {
 
-    if ($ldap_entry && $this->mail_attr) { // not using template
+    // Not using template.
+    if ($ldap_entry && $this->mail_attr) {
       $mail = isset($ldap_entry[$this->mail_attr][0]) ? $ldap_entry[$this->mail_attr][0] : FALSE;
       return $mail;
     }
-    elseif ($ldap_entry && $this->mail_template) {  // template is of form [cn]@illinois.edu
+    // Template is of form [cn]@illinois.edu.
+    elseif ($ldap_entry && $this->mail_template) {
       ldap_servers_module_load_include('inc', 'ldap_servers', 'ldap_servers.functions');
       return ldap_servers_token_replace($ldap_entry, $this->mail_template, 'ldap_entry');
     }
@@ -1088,30 +1192,29 @@ class LdapServer {
     }
   }
 
-	/**
-	 * @param array $ldap_entry
-	 *
-	 * @return object|bool
+  /**
+   * @param array $ldap_entry
+   *
+   * @return object|bool
    *   Drupal file object image user's thumbnail or FALSE if none present or
    *   ERROR happens.
-	 */
-	public function userPictureFromLdapEntry($ldap_entry, $drupal_username = FALSE) {
-		if ($ldap_entry && $this->picture_attr) {
-			//Check if ldap entry has been provisioned.
-
-			$image_data = isset($ldap_entry[$this->picture_attr][0]) ? $ldap_entry[$this->picture_attr][0] : FALSE;
-			if (!$image_data) {
-				return FALSE;
-			}
+   */
+  public function userPictureFromLdapEntry($ldap_entry, $drupal_username = FALSE) {
+    if ($ldap_entry && $this->picture_attr) {
+      // Check if ldap entry has been provisioned.
+      $image_data = isset($ldap_entry[$this->picture_attr][0]) ? $ldap_entry[$this->picture_attr][0] : FALSE;
+      if (!$image_data) {
+        return FALSE;
+      }
 
-			$md5thumb = md5($image_data);
+      $md5thumb = md5($image_data);
 
-			/**
-			 * If the existing account already has picture check if it has changed. If
+      /**
+       * If the existing account already has picture check if it has changed. If
        * so remove the old file and create the new one. If a picture is not set
        * but the account has an md5 hash, something is wrong and we exit.
-			 */
-			if ($drupal_username && $account = user_load_by_name($drupal_username)) {
+       */
+      if ($drupal_username && $account = user_load_by_name($drupal_username)) {
         if ($account->uid == 0 || $account->uid == 1) {
           return FALSE;
         }
@@ -1141,24 +1244,25 @@ class LdapServer {
       return $this->savePictureData($image_data, $md5thumb);
     }
     return FALSE;
-	}
-
+  }
 
   /**
    * @param $image_data
    * @param $md5thumb
+   *
+   * @return bool|\stdClass
    */
   private function savePictureData($image_data, $md5thumb) {
-    //Create tmp file to get image format.
+    // Create tmp file to get image format.
     $filename = uniqid();
     $fileuri = file_directory_temp() . '/' . $filename;
     $size = file_put_contents($fileuri, $image_data);
     $info = image_get_info($fileuri);
     unlink($fileuri);
-    // create file object
+    // Create file object.
     $file = file_save_data($image_data, file_default_scheme() . '://' . variable_get('user_picture_path') . '/' . $filename . '.' . $info['extension']);
     $file->md5Sum = $md5thumb;
-    // standard Drupal validators for user pictures
+    // Standard Drupal validators for user pictures.
     $validators = [
       'file_validate_is_image' => [],
       'file_validate_image_resolution' => [variable_get('user_picture_dimensions', '85x85')],
@@ -1176,11 +1280,11 @@ class LdapServer {
     }
   }
 
-
   /**
    * @param array $ldap_entry
    *
-   * @return string user's PUID or permanent user id (within ldap), converted from binary, if applicable
+   * @return string
+   *   user's PUID or permanent user id (within ldap), converted from binary, if applicable
    */
   public function userPuidFromLdapEntry($ldap_entry) {
 
@@ -1202,17 +1306,21 @@ class LdapServer {
   }
 
   /**
-   *  @param mixed $user
-   *    - drupal user object (stdClass Object)
+   * @param mixed $user
+   *   - drupal user object (stdClass Object)
    *    - ldap entry of user (array)
    *    - ldap dn of user (string)
    *    - drupal username of user (string)
    *
-   *  @return array $ldap_user_entry (with top level keys of 'dn', 'mail', 'sid' and 'attr' )
+   * @return array $ldap_user_entry (with top level keys of 'dn', 'mail', 'sid' and 'attr' )
    */
   public function user_lookup($user) {
     return $this->userUserToExistingLdapEntry($user);
   }
+
+  /**
+   *
+   */
   public function userUserToExistingLdapEntry($user) {
 
     if (is_object($user)) {
@@ -1222,7 +1330,8 @@ class LdapServer {
       $user_ldap_entry = $user;
     }
     elseif (is_scalar($user)) {
-      if (strpos($user, '=') === FALSE) { // username
+      // Username.
+      if (strpos($user, '=') === FALSE) {
         $user_ldap_entry = $this->userUserNameToExistingLdapEntry($user);
       }
       else {
@@ -1238,10 +1347,13 @@ class LdapServer {
    * @param string $drupal_user_name
    *
    * @param string or int $prov_event
-   *   This could be anything, particularly when used by other modules.  Other modules should use string like 'mymodule_myevent'
-   *   LDAP_USER_EVENT_ALL signifies get all attributes needed by all other contexts/ops
+   *   This could be anything, particularly when used by other modules.
+   *   Other modules should use string like 'mymodule_myevent'
+   *   LDAP_USER_EVENT_ALL signifies get all attributes needed by all other
+   *   contexts/ops.
    *
-   * @return associative array representing ldap data of a user.  for example of returned value.
+   * @return array
+   *   representing ldap data of a user.  for example of returned value.
    *   'sid' => ldap server id
    *   'mail' => derived from ldap mail (not always populated).
    *   'dn'   => dn of user
@@ -1250,13 +1362,13 @@ class LdapServer {
    */
   public function userUserNameToExistingLdapEntry($drupal_user_name, $ldap_context = NULL) {
 
-    $watchdog_tokens = array('%drupal_user_name' => $drupal_user_name);
+    $watchdog_tokens = ['%drupal_user_name' => $drupal_user_name];
     $ldap_username = $this->userUsernameToLdapNameTransform($drupal_user_name, $watchdog_tokens);
     if (!$ldap_username) {
       return FALSE;
     }
     if (!$ldap_context) {
-      $attributes = array();
+      $attributes = [];
     }
     else {
       $attribute_maps = ldap_servers_attributes_needed($this->sid, $ldap_context);
@@ -1264,16 +1376,19 @@ class LdapServer {
     }
 
     foreach ($this->basedn as $basedn) {
-      if (empty($basedn)) continue;
+      if (empty($basedn)) {
+        continue;
+      }
       $filter = '(' . $this->user_attr . '=' . ldap_server_massage_text($ldap_username, 'attr_value', LDAP_SERVER_MASSAGE_QUERY_LDAP) . ')';
       $result = $this->search($basedn, $filter, $attributes);
-      if (!$result || !isset($result['count']) || !$result['count']) continue;
+      if (!$result || !isset($result['count']) || !$result['count']) {
+        continue;
+      }
 
       // Must find exactly one user for authentication to work.
-
       if ($result['count'] != 1) {
         $count = $result['count'];
-        watchdog('ldap_servers', "Error: !count users found with $filter under $basedn.", array('!count' => $count), WATCHDOG_ERROR);
+        watchdog('ldap_servers', "Error: !count users found with $filter under $basedn.", ['!count' => $count], WATCHDOG_ERROR);
         continue;
       }
       $match = $result[0];
@@ -1285,7 +1400,7 @@ class LdapServer {
       $name_attr = $this->user_attr;
 
       if (isset($match[$name_attr][0])) {
-        // leave name
+        // Leave name.
       }
       elseif (isset($match[drupal_strtolower($name_attr)][0])) {
         $name_attr = drupal_strtolower($name_attr);
@@ -1293,12 +1408,12 @@ class LdapServer {
       }
       else {
         if ($this->bind_method == LDAP_SERVERS_BIND_METHOD_ANON_USER) {
-          $result = array(
+          $result = [
             'dn' => $match['dn'],
             'mail' => $this->userEmailFromLdapEntry($match),
             'attr' => $match,
             'sid' => $this->sid,
-            );
+          ];
           return $result;
         }
         else {
@@ -1316,12 +1431,12 @@ class LdapServer {
       // loop through all possible options.
       foreach ($match[$name_attr] as $value) {
         if (drupal_strtolower(trim($value)) == drupal_strtolower($ldap_username)) {
-          $result = array(
+          $result = [
             'dn' => $match['dn'],
             'mail' => $this->userEmailFromLdapEntry($match),
             'attr' => $match,
             'sid' => $this->sid,
-          );
+          ];
           return $result;
         }
       }
@@ -1331,36 +1446,44 @@ class LdapServer {
   /**
    * Is a user a member of group?
    *
-   * @param string $group_dn MIXED CASE
+   * @param string $group_dn
+   *   MIXED CASE.
    * @param mixed $user
-   *    - drupal user object (stdClass Object)
+   *   - drupal user object (stdClass Object)
    *    - ldap entry of user (array)
    *    - ldap dn of user (array)
    *    - drupal user name (string)
-   * @param enum $nested = NULL (default to server configuration), TRUE, or FALSE indicating to test for nested groups
+   * @param enum $nested
+   *   = NULL (default to server configuration), TRUE, or FALSE indicating to
+   *   test for nested groups.
+   *
+   * @return bool
    */
   public function groupIsMember($group_dn, $user, $nested = NULL) {
 
     $nested = ($nested === TRUE || $nested === FALSE) ? $nested : $this->groupNested;
     $group_dns = $this->groupMembershipsFromUser($user, 'group_dns', $nested);
-    // while list of group dns is going to be in correct mixed case, $group_dn may not since it may be derived from user entered values
-    // so make sure in_array() is case insensitive
+    // While list of group dns is going to be in correct mixed case, $group_dn may not since it may be derived from user entered values
+    // so make sure in_array() is case insensitive.
     return (is_array($group_dns) && in_array(drupal_strtolower($group_dn), $this->dnArrayToLowerCase($group_dns)));
   }
 
   /**
    * NOT TESTED
-   * add a group entry
+   * add a group entry.
    *
-   * @param string $group_dn as ldap dn
-   * @param array $attributes in key value form
-   *    $attributes = array(
+   * @param string $group_dn
+   *   as ldap dn.
+   * @param array $attributes
+   *   in key value form
+   *   $attributes = array(
    *      "attribute1" = "value",
    *      "attribute2" = array("value1", "value2"),
    *      )
+   *
    * @return boolean success
    */
-  public function groupAddGroup($group_dn, $attributes = array()) {
+  public function groupAddGroup($group_dn, $attributes = []) {
 
     if ($this->dnExists($group_dn, 'boolean')) {
       return FALSE;
@@ -1373,24 +1496,22 @@ class LdapServer {
     /**
      * 2. give other modules a chance to add or alter attributes
      */
-    $context = array(
+    $context = [
       'action' => 'add',
-      'corresponding_drupal_data' => array($group_dn => $attributes),
+      'corresponding_drupal_data' => [$group_dn => $attributes],
       'corresponding_drupal_data_type' => 'group',
-    );
-    $ldap_entries = array($group_dn => $attributes);
+    ];
+    $ldap_entries = [$group_dn => $attributes];
     drupal_alter('ldap_entry_pre_provision', $ldap_entries, $this, $context);
     $attributes = $ldap_entries[$group_dn];
 
-
-     /**
+    /**
      * 4. provision ldap entry
      *   @todo how is error handling done here?
      */
     $ldap_entry_created = $this->createLdapEntry($attributes, $group_dn);
 
-
-     /**
+    /**
      * 5. allow other modules to react to provisioned ldap entry
      *   @todo how is error handling done here?
      */
@@ -1406,12 +1527,15 @@ class LdapServer {
 
   /**
    * NOT TESTED
-   * remove a group entry
+   * remove a group entry.
    *
-   * @param string $group_dn as ldap dn
-   * @param boolean $only_if_group_empty
+   * @param string $group_dn
+   *   as ldap dn.
+   * @param bool $only_if_group_empty
    *   TRUE = group should not be removed if not empty
-   *   FALSE = groups should be deleted regardless of members
+   *   FALSE = groups should be deleted regardless of members.
+   *
+   * @return bool
    */
   public function groupRemoveGroup($group_dn, $only_if_group_empty = TRUE) {
 
@@ -1428,21 +1552,25 @@ class LdapServer {
 
   /**
    * NOT TESTED
-   * add a member to a group
+   * add a member to a group.
    *
-   * @param string $ldap_user_dn as ldap dn
+   * @param string $ldap_user_dn
+   *   as ldap dn.
    * @param mixed $user
-   *    - drupal user object (stdClass Object)
-   *    - ldap entry of user (array) (with top level keys of 'dn', 'mail', 'sid' and 'attr' )
+   *   - drupal user object (stdClass Object)
+   *    - ldap entry of user (array) (with top level keys of 'dn', 'mail',
+   *   'sid' and 'attr' )
    *    - ldap dn of user (array)
    *    - drupal username of user (string)
+   *
+   * @return bool
    */
   public function groupAddMember($group_dn, $user) {
 
     $user_ldap_entry = $this->userUserToExistingLdapEntry($user);
     $result = FALSE;
     if ($user_ldap_entry && $this->groupGroupEntryMembershipsConfigured) {
-      $add = array();
+      $add = [];
       $add[$this->groupMembershipsAttr] = $user_ldap_entry['dn'];
       $this->connectAndBindIfNotAlready();
       $result = @ldap_mod_add($this->connection, $group_dn, $add);
@@ -1453,21 +1581,25 @@ class LdapServer {
 
   /**
    * NOT TESTED
-   * remove a member from a group
+   * remove a member from a group.
    *
-   * @param string $group_dn as ldap dn
+   * @param string $group_dn
+   *   as ldap dn.
    * @param mixed $user
-   *    - drupal user object (stdClass Object)
-   *    - ldap entry of user (array) (with top level keys of 'dn', 'mail', 'sid' and 'attr' )
+   *   - drupal user object (stdClass Object)
+   *    - ldap entry of user (array) (with top level keys of 'dn', 'mail',
+   *   'sid' and 'attr' )
    *    - ldap dn of user (array)
    *    - drupal username of user (string)
+   *
+   * @return bool
    */
   public function groupRemoveMember($group_dn, $user) {
 
     $user_ldap_entry = $this->userUserToExistingLdapEntry($user);
     $result = FALSE;
     if ($user_ldap_entry && $this->groupGroupEntryMembershipsConfigured) {
-      $del = array();
+      $del = [];
       $del[$this->groupMembershipsAttr] = $user_ldap_entry['dn'];
       $this->connectAndBindIfNotAlready();
       $result = @ldap_mod_del($this->connection, $group_dn, $del);
@@ -1475,32 +1607,34 @@ class LdapServer {
     return $result;
   }
 
-
   /**
+   * Get all members of a group.
    *
    * @todo: NOT IMPLEMENTED: nested groups
    *
-   * get all members of a group
-   *
-   * @param string $group_dn as ldap dn
+   * @param string $group_dn
+   *   as ldap dn.
    *
-   * @return FALSE on error otherwise array of group members (could be users or groups)
+   * @return false
+   *   on error otherwise array of group members (could be users or groups)
    */
   public function groupAllMembers($group_dn) {
     if (!$this->groupGroupEntryMembershipsConfigured) {
       return FALSE;
     }
-    $attributes = array($this->groupMembershipsAttr, 'cn');
+    $attributes = [$this->groupMembershipsAttr, 'cn'];
     $group_entry = $this->dnExists($group_dn, 'ldap_entry', $attributes);
     if (!$group_entry) {
       return FALSE;
     }
     else {
-      if (empty($group_entry['cn'])) { // if attributes weren't returned, don't give false  empty group
+      // If attributes weren't returned, don't give false  empty group.
+      if (empty($group_entry['cn'])) {
         return FALSE;
       }
       if (empty($group_entry[$this->groupMembershipsAttr])) {
-        return array(); // if no attribute returned, no members
+        // If no attribute returned, no members.
+        return [];
       }
       $members = $group_entry[$this->groupMembershipsAttr];
       if (isset($members['count'])) {
@@ -1516,17 +1650,25 @@ class LdapServer {
   }
 
   /**
-   *   NOT IMPLEMENTED
+   * NOT IMPLEMENTED
    * recurse through all child groups and add members.
    *
-   * @param array $current_group_entries of ldap group entries that are starting point.  should include at least 1 entry.
-   * @param array $all_group_dns as array of all groups user is a member of.  MIXED CASE VALUES
-   * @param array $tested_group_ids as array of tested group dn, cn, uid, etc.  MIXED CASE VALUES
-   *   whether these value are dn, cn, uid, etc depends on what attribute members, uniquemember, memberUid contains
-   *   whatever attribute is in $this->$tested_group_ids to avoid redundant recursing
-   * @param int $level of recursion
-   * @param int $max_levels as max recursion allowed
-   *
+   * @param array $current_group_entries
+   *   of ldap group entries that are starting point.  should include at least
+   *   1 entry.
+   * @param array $all_group_dns
+   *   as array of all groups user is a member of.  MIXED CASE VALUES.
+   * @param array $tested_group_ids
+   *   as array of tested group dn, cn, uid, etc.  MIXED CASE VALUES
+   *   whether these value are dn, cn, uid, etc depends on what attribute
+   *   members, uniquemember, memberUid contains whatever attribute is in
+   *   $this->$tested_group_ids to avoid redundant recursing.
+   * @param int $level
+   *   of recursion.
+   * @param int $max_levels
+   *   as max recursion allowed.
+   *
+   * @return bool
    */
   public function groupMembersResursive($current_member_entries, &$all_member_dns, &$tested_group_ids, $level, $max_levels, $object_classes = FALSE) {
 
@@ -1538,14 +1680,15 @@ class LdapServer {
     };
 
     foreach ($current_member_entries as $i => $member_entry) {
-      // 1.  Add entry itself if of the correct type to $all_member_dns
+      // 1.  Add entry itself if of the correct type to $all_member_dns.
       $objectClassMatch = (!$object_classes || (count(array_intersect(array_values($member_entry['objectclass']), $object_classes)) > 0));
       $objectIsGroup = in_array($this->groupObjectClass, array_values($member_entry['objectclass']));
-      if ($objectClassMatch && !in_array($member_entry['dn'], $all_member_dns)) { // add member
+      // Add member.
+      if ($objectClassMatch && !in_array($member_entry['dn'], $all_member_dns)) {
         $all_member_dns[] = $member_entry['dn'];
       }
 
-      // 2. If its a group, keep recurse the group for descendants
+      // 2. If its a group, keep recurse the group for descendants.
       if ($objectIsGroup && $level < $max_levels) {
         if ($this->groupMembershipsAttrMatchingUserAttr == 'dn') {
           $group_id = $member_entry['dn'];
